#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <stdlib.h>
#include <BipCpi.h>


///////////////////////////////////////////////////////////
// ASCIIToUnicode
CciChar* ASCIIToUnicode(const char* aStr)
{
	int	iLength = sizeof(CciChar) * (strlen(aStr) + 1);
	CciChar	*ucsString = (CciChar *)malloc(iLength);
	int	iRc;
	cciMbsToUcs(
		&iRc,
		aStr,
		ucsString,
		iLength,
		1208);
	return(ucsString);
}

///////////////////////////////////////////////////////////
// UnicodeToASCII
char *UnicodeToASCII(CciChar* ucsString)
{
	int	iRc;
	// WARNING!!:  The wcslen() function used in the following statement
	// is not believed to be portable.
	int iLength = wcslen(ucsString) + 1;
	char *mbString = (char *)malloc(iLength);
	cciUcsToMbs(
		&iRc,
		ucsString,
		mbString,
		iLength,
		1208);
	return(mbString);
}

///////////////////////////////////////////////////////////
// GetName
char *GetName(CciParser *parser, CciElement *element)
{
	int	iRc;
	CciChar	name[256];
	cpiElementName(&iRc, element, name, sizeof(name));
	if (iRc != 0)
	{
		return(0);
	}
	return(UnicodeToASCII(name));
}


///////////////////////////////////////////////////////////
// GetStringValue
char *GetStringValue(CciParser *parser, CciElement *element)
{
	int	iRc;
	CciChar	value[256];
	cpiElementCharacterValue(&iRc, element, value, sizeof(value));
	if (iRc != 0)
	{
		return(0);
	}
	return(UnicodeToASCII(value));
}

